
default_derive!{
    pub struct ObjectRelation {
        rel: String
    }
}

impl TryFrom<&str> for ObjectRelation {
    type Error = &'static str;

    fn try_from(value: &str) -> Result<Self, Self::Error> {
        if value.len() <= 255 {
            Ok(ObjectRelation { rel: value.to_string() })
        }
        else {
            Err("Failed to parse ObjectRelation")
        }
    }
}

impl Into<String> for ObjectRelation {
    fn into(self) -> String {
        self.rel
    }
}

#[test]
fn oversized() {
    let rel: Result<ObjectRelation, _> = format!("{:>256}", "Test").as_str().try_into();
    assert!(rel.is_err())
}

#[test]
fn valid1() {
    let rel: Result<ObjectRelation, _> = "relation".try_into();
    assert_eq!(rel, Ok(ObjectRelation { rel: "relation".to_string() }))
}